// Generated by CoffeeScript 1.10.0
(function() {
  var CND, alert, append, as_number, as_numbers, badge, debug, deepcopy_entry, deepcopy_reducers, echo, fuse, help, info, log, meld, minus_aleph, normalize_points, normalize_tag, plus_aleph, reduce_tag, rpr, setting_keys_of_cover_and_intersect, sort_entries_by_insertion_order, sort_ids_by_insertion_order, unique, urge, warn, whisper,
    slice = [].slice,
    indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

  CND = require('cnd');

  rpr = CND.rpr.bind(CND);

  badge = 'INTERSKIPLIST';

  log = CND.get_logger('plain', badge);

  info = CND.get_logger('info', badge);

  whisper = CND.get_logger('whisper', badge);

  alert = CND.get_logger('alert', badge);

  debug = CND.get_logger('debug', badge);

  warn = CND.get_logger('warn', badge);

  help = CND.get_logger('help', badge);

  urge = CND.get_logger('urge', badge);

  echo = CND.echo.bind(CND);

  plus_aleph = Symbol["for"]('+א');

  minus_aleph = Symbol["for"]('-א');

  this["new"] = function(settings) {
    var R, isl_settings, ref, substrate;
    isl_settings = {
      minIndex: minus_aleph,
      maxIndex: plus_aleph,
      compare: function(a, b) {
        if (a === b && (a === plus_aleph || a === minus_aleph)) {
          return 0;
        }
        if ((a === plus_aleph) || (b === minus_aleph)) {
          return +1;
        }
        if ((a === minus_aleph) || (b === plus_aleph)) {
          return -1;
        }
        if (a > b) {
          return +1;
        }
        if (a < b) {
          return -1;
        }
        return 0;
      }
    };
    substrate = new (require('interval-skip-list'))(isl_settings);
    substrate.toString = substrate.inspect = function() {
      return "{ interval-skip-list }";
    };
    R = {
      '~isa': 'CND/interskiplist',
      '%self': substrate,
      'entry-by-ids': {},
      'idx-by-names': {},
      'ids-by-names': {},
      'name-by-ids': {},
      'idx-by-ids': {},
      'ids': [],
      'idx': -1,
      'min': null,
      'max': null,
      'fmin': null,
      'fmax': null,
      'reducers': (ref = settings != null ? settings['reducers'] : void 0) != null ? ref : null
    };
    return R;
  };

  this.copy = function(me) {
    var R, entry, i, len, ref, settings;
    settings = {
      reducers: deepcopy_reducers(me)
    };
    R = this["new"](settings);
    ref = this.entries_of(me);
    for (i = 0, len = ref.length; i < len; i++) {
      entry = ref[i];
      this.add(R, deepcopy_entry(null, entry));
    }
    return R;
  };

  this.add = function(me, entry) {
    var arity, base, global_idx, group_idx, hi, id, lo, name, ref;
    if ((arity = arguments.length) !== 2) {
      throw new Error("expected 2 arguments, got " + arity);
    }
    if (!CND.isa_pod(entry)) {
      throw new Error("expected a POD, got a " + (CND.type_of(entry)));
    }
    lo = entry.lo, hi = entry.hi, id = entry.id, name = entry.name;
    if (lo == null) {
      throw new Error("expected setting for 'lo', found none");
    }
    if (hi == null) {
      throw new Error("expected setting for 'hi', found none");
    }
    lo = as_number(lo);
    hi = as_number(hi);
    if (name == null) {
      name = '+';
    }
    group_idx = (me['idx-by-names'][name] = ((ref = me['idx-by-names'][name]) != null ? ref : -1) + 1);
    global_idx = (me['idx'] += +1);
    if (id == null) {
      id = name + "[" + group_idx + "]";
    }
    entry['lo'] = lo;
    entry['hi'] = hi;
    entry['idx'] = global_idx;
    entry['id'] = id;
    entry['name'] = name;
    entry['size'] = hi - lo + 1;
    if (entry['tag'] != null) {
      entry['tag'] = normalize_tag(entry['tag']);
    }
    if (me['min'] == null) {
      me['min'] = lo;
    }
    me['min'] = Math.min(me['min'], lo);
    if (me['max'] == null) {
      me['max'] = hi;
    }
    me['max'] = Math.max(me['max'], lo);
    if (CND.isa_number(lo)) {
      if (me['fmin'] == null) {
        me['fmin'] = lo;
      }
      me['fmin'] = Math.min(me['fmin'], lo);
    }
    if (CND.isa_number(hi)) {
      if (me['fmax'] == null) {
        me['fmax'] = hi;
      }
      me['fmax'] = Math.max(me['fmax'], lo);
    }
    me['name-by-ids'][id] = name;
    me['idx-by-ids'][id] = global_idx;
    me['entry-by-ids'][id] = entry != null ? entry : null;
    ((base = me['ids-by-names'])[name] != null ? base[name] : base[name] = []).push(id);
    me['%self'].insert(id, lo, hi);
    me['ids'].push(id);
    return id;
  };

  this["delete"] = function(me, id) {
    return me['%self'].remove(id);
  };

  this.match = function(me, points, settings) {
    if (settings == null) {
      settings = {};
    }
    return this._cover_or_intersect(me, 'match', points, settings);
  };

  this.intersect = function(me, points, settings) {
    if (settings == null) {
      settings = {};
    }
    return this._cover_or_intersect(me, 'intersect', points, settings);
  };

  this._cover_or_intersect = function(me, mode, points, settings) {
    var R, entry, expected, got, keys, pick;
    if (!CND.is_subset((keys = Object.keys(settings)), setting_keys_of_cover_and_intersect)) {
      expected = setting_keys_of_cover_and_intersect.join(', ');
      got = keys.join(', ');
      throw new Error("expected settings out of " + expected + ", got " + got);
    }
    pick = settings.pick;
    if (mode === 'match') {
      R = this._find_ids_with_all_points(me, points);
    } else {
      R = this._find_ids_with_any_points(me, points);
    }
    if (pick === 'id') {
      return R;
    }
    R = this.entries_of(me, R);
    if (pick != null) {
      R = (function() {
        var i, len, results;
        results = [];
        for (i = 0, len = R.length; i < len; i++) {
          entry = R[i];
          results.push(entry[pick]);
        }
        return results;
      })();
      if (pick === 'tag') {
        return reduce_tag(R);
      }
    }
    return fuse(R);
  };

  setting_keys_of_cover_and_intersect = ['pick'];

  this.entries_of = function(me, ids) {
    var R, _, entry, i, id, len;
    if (ids == null) {
      ids = null;
    }
    if (ids == null) {
      R = (function() {
        var ref, results;
        ref = me['entry-by-ids'];
        results = [];
        for (_ in ref) {
          entry = ref[_];
          results.push(entry);
        }
        return results;
      })();
    } else {
      R = [];
      for (i = 0, len = ids.length; i < len; i++) {
        id = ids[i];
        if ((entry = me['entry-by-ids'][id]) == null) {
          throw new Error("unknown ID " + (rpr(id)));
        }
        R.push(entry);
      }
    }
    return sort_entries_by_insertion_order(me, R);
  };

  this._find_ids_with_any_points = function(me, points) {
    var R, i, id, ids, j, len, len1, point, ref;
    points = normalize_points(points);
    if (points.length < 2) {
      return (ref = me['%self']).findContaining.apply(ref, points);
    }
    R = new Set();
    for (i = 0, len = points.length; i < len; i++) {
      point = points[i];
      ids = me['%self'].findContaining(point);
      for (j = 0, len1 = ids.length; j < len1; j++) {
        id = ids[j];
        R.add(id);
      }
    }
    return sort_ids_by_insertion_order(me, Array.from(R));
  };

  this._find_ids_with_all_points = function(me, points) {
    var ref;
    points = normalize_points(points);
    return (ref = me['%self']).findContaining.apply(ref, points);
  };

  this.intervals_from_points = function() {
    var R, i, last_hi, last_lo, last_point, len, me, mixin, mixins, point, points;
    me = arguments[0], points = arguments[1], mixins = 3 <= arguments.length ? slice.call(arguments, 2) : [];
    mixin = function(lohi) {
      if (!(mixins.length > 0)) {
        return lohi;
      }
      return Object.assign.apply(Object, [{}].concat(slice.call(mixins), [lohi]));
    };
    if (!CND.isa_list(points)) {
      points = [points];
    }
    points = unique(as_numbers(points));
    points.sort(function(a, b) {
      if (a > b) {
        return +1;
      }
      if (a < b) {
        return -1;
      }
      return 0;
    });
    R = [];
    last_point = null;
    last_lo = null;
    last_hi = null;
    for (i = 0, len = points.length; i < len; i++) {
      point = points[i];
      if (last_lo == null) {
        last_lo = point;
        last_hi = point;
        last_point = point;
        continue;
      }
      if (point === last_point + 1) {
        last_hi = point;
        last_point = point;
        continue;
      }
      R.push(mixin({
        lo: last_lo,
        hi: last_hi
      }));
      last_lo = point;
      last_hi = point;
      last_point = point;
    }
    if ((last_lo != null) && (last_hi != null)) {
      R.push(mixin({
        lo: last_lo,
        hi: last_hi
      }));
    }
    return R;
  };

  this.aggregate = function(me, points_or_entries, reducers) {
    var R, averages, cache, count, entries, entry, exclude, functions, i, ids_and_values, j, key, len, len1, points, points_or_entry, reducer, reducer_fallback, reducer_include, ref, ref1, ref2, ref3, ref4, ref5, sum, tag_keys, target, value;
    if (reducers == null) {
      reducers = {};
    }

    /* TAINT The functionality of this method has since been re-implemented in a more generic fashion
    by the MULTIMIX `mix` method; accordingly, `aggregate` should use that facility (and maybe be renamed
    to `mix` itself).
     */
    if ((reducers != null) && !CND.isa_pod(reducers)) {
      throw new Error("expected a POD for reducer, got a " + (CND.type_of(reducers)));
    }

    /* Separate points from entries, splice them together with those points found for the points, and sort
    the result:
     */
    if (!CND.isa_list(points_or_entries)) {
      points_or_entries = [points_or_entries];
    }
    points = [];
    entries = [];
    for (i = 0, len = points_or_entries.length; i < len; i++) {
      points_or_entry = points_or_entries[i];
      if ((ref = CND.type_of(points_or_entry)) === 'number' || ref === 'text') {
        points.push(points_or_entry);
      } else {
        entries.push(points_or_entry);
      }
    }
    if (points.length > 0) {
      append(entries, this.match(me, points));
    }
    sort_entries_by_insertion_order(me, entries);
    R = {};
    cache = {};
    averages = {};
    reducers = Object.assign({}, reducers, (ref1 = me['reducers']) != null ? ref1 : {});
    tag_keys = (function() {
      var results;
      results = [];
      for (key in reducers) {
        value = reducers[key];
        if (value === 'tag') {
          results.push(key);
        }
      }
      return results;
    })();
    exclude = (function() {
      var j, len1, ref2, results;
      ref2 = ['idx', 'id', 'lo', 'hi', 'size'];
      results = [];
      for (j = 0, len1 = ref2.length; j < len1; j++) {
        key = ref2[j];
        if (!(key in reducers)) {
          results.push(key);
        }
      }
      return results;
    })();
    reducer_fallback = (ref2 = reducers['*']) != null ? ref2 : 'assign';
    reducer_include = reducer_fallback;
    if (reducer_include === 'skip') {
      reducer_include = 'assign';
    }
    functions = {};
    for (key in reducers) {
      reducer = reducers[key];
      if (reducer === 'include') {
        reducers[key] = reducer_include;
        continue;
      }
      if (CND.isa_function(reducer)) {
        functions[key] = reducer;
        reducers[key] = 'function';
      }
    }
    if (!((indexOf.call(exclude, 'tag') >= 0) || ('tag' in reducers))) {
      tag_keys.push('tag');
      reducers['tag'] = 'tag';
    }
    for (j = 0, len1 = entries.length; j < len1; j++) {
      entry = entries[j];
      for (key in entry) {
        value = entry[key];
        if (indexOf.call(exclude, key) >= 0) {
          continue;
        }
        reducer = (ref3 = reducers[key]) != null ? ref3 : reducer_fallback;
        switch (reducer) {
          case 'skip':
            continue;
          case 'list':
            (R[key] != null ? R[key] : R[key] = []).push(value);
            break;
          case 'add':
            R[key] = ((ref4 = R[key]) != null ? ref4 : 0) + value;
            break;
          case 'assign':
            R[key] = value;
            break;
          case 'tag':
            meld((target = R[key] != null ? R[key] : R[key] = []), value);
            break;
          case 'function':
            (cache[key] != null ? cache[key] : cache[key] = []).push([entry['id'], value]);
            break;
          case 'average':
            target = averages[key] != null ? averages[key] : averages[key] = [0, 0];
            target[0] = target[0] + value;
            target[1] = target[1] + 1;
            break;
          default:
            throw new Error("unknown reducer " + (rpr(reducer)));
        }
      }
    }

    /* tags */
    for (key in R) {
      value = R[key];
      if (indexOf.call(tag_keys, key) < 0) {
        continue;
      }
      R[key] = reduce_tag(R[key]);
    }

    /* averages */
    for (key in averages) {
      ref5 = averages[key], sum = ref5[0], count = ref5[1];
      R[key] = sum / count;
    }

    /* functions */
    for (key in cache) {
      ids_and_values = cache[key];
      R[key] = functions[key](ids_and_values, R, entries);
    }
    return R;
  };

  deepcopy_entry = function(me, entry) {
    return JSON.parse(JSON.stringify(entry));
  };

  deepcopy_reducers = function(me) {
    var R, key, reducers, value;
    if ((reducers = me['reducers']) == null) {
      return null;
    }
    R = JSON.parse(JSON.stringify(reducers));
    for (key in reducers) {
      value = reducers[key];
      if (CND.isa_function(value)) {
        R[key] = value;
      }
    }
    return R;
  };

  sort_entries_by_insertion_order = function(me, entries) {
    entries.sort(function(a, b) {
      if (a['idx'] > b['idx']) {
        return +1;
      }
      if (a['idx'] < b['idx']) {
        return -1;
      }
      return 0;
    });
    return entries;
  };

  sort_ids_by_insertion_order = function(me, ids) {
    var idxs;
    idxs = me['idx-by-ids'];
    ids.sort(function(a, b) {
      if (idxs[a] > idxs[b]) {
        return +1;
      }
      if (idxs[a] < idxs[b]) {
        return -1;
      }
      return 0;
    });
    return ids;
  };

  as_number = function(x) {
    var length, type;
    if ((x === (-Infinity) || x === (+Infinity)) || CND.isa_number(x)) {
      return x;
    }
    if ((type = CND.type_of(x)) !== 'text') {
      throw new Error("expected number or single character text, got a " + type);
    }
    if ((length = (Array.from(x)).length) !== 1) {
      throw new Error("expected single character text, got one of length " + length);
    }
    return x.codePointAt(0);
  };

  as_numbers = function(list) {
    var i, len, results, x;
    results = [];
    for (i = 0, len = list.length; i < len; i++) {
      x = list[i];
      results.push(as_number(x));
    }
    return results;
  };

  normalize_points = function(points) {
    if (!CND.isa_list(points)) {
      points = [points];
    }
    return as_numbers(points);
  };

  normalize_tag = function(tag) {

    /* Given a single string or a list of strings, return a new list that contains all whitespace-delimited
    words in the strings
     */
    var R, i, len, t;
    if (!CND.isa_list(tag)) {
      return normalize_tag([tag]);
    }
    R = [];
    for (i = 0, len = tag.length; i < len; i++) {
      t = tag[i];
      if (t.length === 0) {
        continue;
      }
      R.splice.apply(R, [R.length, 0].concat(slice.call(t.split(/\s+/))));
    }

    /* TAINT consider to return `unique R` instead */
    return R;
  };

  unique = function(list) {

    /* Return a copy of `list´ that only contains the last occurrence of each value */

    /* TAINT consider to modify, not copy `list` */
    var R, element, i, idx, ref, seen;
    seen = new Set();
    R = [];
    for (idx = i = ref = list.length - 1; i >= 0; idx = i += -1) {
      element = list[idx];
      if (seen.has(element)) {
        continue;
      }
      seen.add(element);
      R.unshift(element);
    }
    return R;
  };

  append = function(a, b) {

    /* Append elements of list `b` to list `a` */

    /* TAINT JS has `[]::concat` */
    a.splice.apply(a, [a.length, 0].concat(slice.call(b)));
    return a;
  };

  meld = function(list, value) {

    /* When `value` is a list, `append` it to `list`; else, `push` `value` to `list` */
    if (CND.isa_list(value)) {
      append(list, value);
    } else {
      list.push(value);
    }
    return list;
  };

  fuse = function(list) {

    /* Flatten `list`, then apply `unique` to it. Does not copy `list` but modifies it */
    var R, element, i, len;
    R = [];
    for (i = 0, len = list.length; i < len; i++) {
      element = list[i];
      meld(R, element);
    }
    R = unique(R);
    list.splice.apply(list, [0, list.length].concat(slice.call(R)));
    return list;
  };

  reduce_tag = function(raw) {
    var R, exclude, i, idx, ref, source, tag;
    source = fuse(raw);
    R = [];
    exclude = null;
    for (idx = i = ref = source.length - 1; i >= 0; idx = i += -1) {
      tag = source[idx];
      if ((exclude != null) && exclude.has(tag)) {
        continue;
      }
      if (tag.startsWith('-')) {
        if (tag === '-*') {
          break;
        }
        (exclude != null ? exclude : exclude = new Set()).add(tag.slice(1));
        continue;
      }
      R.unshift(tag);
    }
    return R;
  };

}).call(this);

//# sourceMappingURL=main.js.map
