// Generated by CoffeeScript 1.10.0
(function() {
  var CND, ISL, alert, badge, debug, echo, find_ids_text, help, hex, include, info, list, log, rpr, s, show, test, urge, warn, whisper,
    indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; },
    slice = [].slice;

  CND = require('cnd');

  rpr = CND.rpr.bind(CND);

  badge = 'INTERSKIPLIST/tests';

  log = CND.get_logger('plain', badge);

  info = CND.get_logger('info', badge);

  whisper = CND.get_logger('whisper', badge);

  alert = CND.get_logger('alert', badge);

  debug = CND.get_logger('debug', badge);

  warn = CND.get_logger('warn', badge);

  help = CND.get_logger('help', badge);

  urge = CND.get_logger('urge', badge);

  echo = CND.echo.bind(CND);

  test = require('guy-test');

  ISL = require('./main');

  this._prune = function() {
    var name, value;
    for (name in this) {
      value = this[name];
      if (name.startsWith('_')) {
        continue;
      }
      if (indexOf.call(include, name) < 0) {
        delete this[name];
      }
    }
    return null;
  };

  this._main = function(handler) {
    if (handler == null) {
      handler = null;
    }
    return test(this, {
      'timeout': 3000
    });
  };

  hex = function(n) {
    return '0x' + n.toString(16);
  };

  s = function(x) {
    return JSON.stringify(x);
  };

  find_ids_text = function() {
    var P, R, me;
    me = arguments[0], P = 2 <= arguments.length ? slice.call(arguments, 1) : [];
    R = ISL._find_ids_with_all_points.apply(ISL, [me].concat(slice.call(P)));
    R.sort();
    return R.join(',');
  };

  list = function(me) {
    var _, entry, i, key, len, ref, ref1, ref2, type, value;
    ref = ISL.entries_of(me);
    for (i = 0, len = ref.length; i < len; i++) {
      entry = ref[i];
      ref2 = ((ref1 = entry['name']) != null ? ref1 : '???/').split(':'), type = ref2[0], _ = ref2[1];
      help((CND.grey(type + '/')) + (CND.steel('interval')) + ': ' + (CND.yellow((hex(entry['lo'])) + "-" + (hex(entry['hi'])))));
      for (key in entry) {
        value = entry[key];
        help((CND.grey(type + '/')) + (CND.steel(key)) + ': ' + (CND.yellow(value)));
      }
    }
    return null;
  };

  show = function(me) {
    var hi, hi_closed, id, left, lo, lo_closed, ref, ref1, results, right;
    echo('                      0         1         2         3         4         5         6         7         8         9         0         1         2         3         4         5         6         7         8         9         ');
    echo('                      01234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789');
    ref = me['%self'].intervalsByMarker;
    results = [];
    for (id in ref) {
      ref1 = ref[id], lo = ref1[0], hi = ref1[1];
      lo_closed = true;
      hi_closed = true;
      if (lo < 0) {
        lo = 0;
        lo_closed = false;
      }
      if (hi > 199) {
        hi = 199;
        hi_closed = false;
      }
      while (id.length < 20) {
        id += ' ';
      }
      if (lo > 199 && hi > 199) {
        echo(id(id + '  ' + (' '.repeat(199)) + '->'));
        continue;
      }
      if (lo === hi) {
        echo(id + '  ' + (' '.repeat(lo)) + 'H');
        continue;
      }
      left = lo_closed ? '[' : '-';
      right = hi_closed ? ']' : '-';
      results.push(echo(id + '  ' + (' '.repeat(lo)) + left + ('-'.repeat(hi - lo - 1)) + right));
    }
    return results;
  };

  this["test interval tree 1"] = function(T) {
    var hi, i, id, intervals, isl, len, lo, ref;
    isl = ISL["new"]();
    intervals = [[1, 3, 'A'], [2, 14, 'B'], [3, 7, 'C'], [4, 4, 'D'], [5, 7, 'E'], [8, 12, 'F1'], [8, 12, 'F2'], [8, 22, 'G'], [10, 13, 'H']];
    for (i = 0, len = intervals.length; i < len; i++) {
      ref = intervals[i], lo = ref[0], hi = ref[1], id = ref[2];
      ISL.add(isl, {
        lo: lo,
        hi: hi,
        id: id
      });
    }
    show(isl);
    T.eq(find_ids_text(isl, 0), '');
    T.eq(find_ids_text(isl, 1), 'A');
    T.eq(find_ids_text(isl, 2), 'A,B');
    T.eq(find_ids_text(isl, 3), 'A,B,C');
    T.eq(find_ids_text(isl, 4), 'B,C,D');
    T.eq(find_ids_text(isl, 5), 'B,C,E');
    T.eq(find_ids_text(isl, 6), 'B,C,E');
    T.eq(find_ids_text(isl, 7), 'B,C,E');
    T.eq(find_ids_text(isl, 8), 'B,F1,F2,G');
    T.eq(find_ids_text(isl, 9), 'B,F1,F2,G');
    T.eq(find_ids_text(isl, 10), 'B,F1,F2,G,H');
    T.eq(find_ids_text(isl, 11), 'B,F1,F2,G,H');
    T.eq(find_ids_text(isl, 12), 'B,F1,F2,G,H');
    T.eq(find_ids_text(isl, 13), 'B,G,H');
    T.eq(find_ids_text(isl, 14), 'B,G');
    T.eq(find_ids_text(isl, 15), 'G');
    T.eq(find_ids_text(isl, 16), 'G');
    T.eq(find_ids_text(isl, 17), 'G');
    T.eq(find_ids_text(isl, 18), 'G');
    return null;
  };

  this["test interval tree 2"] = function(T) {
    var hi, i, intervals, isl, len, lo, ref, tag;
    isl = ISL["new"]();
    intervals = [[1, 3, 'orion'], [2, 14, 'orion'], [3, 7, 'orion'], [4, 4, 'orion'], [5, 7, 'cygnus'], [5, 7, 'orion'], [8, 12, 'aldebaran'], [-12, 8, 'aldebaran'], [8, 22, 'aldebaran'], [10, 13, 'aldebaran'], [11, 15, 'cygnus']];
    for (i = 0, len = intervals.length; i < len; i++) {
      ref = intervals[i], lo = ref[0], hi = ref[1], tag = ref[2];
      ISL.add(isl, {
        lo: lo,
        hi: hi,
        tag: tag
      });
    }
    show(isl);
    T.eq(ISL.match(isl, 0, {
      pick: 'tag'
    }), ["aldebaran"]);
    T.eq(ISL.match(isl, 1, {
      pick: 'tag'
    }), ["orion", "aldebaran"]);
    T.eq(ISL.match(isl, 2, {
      pick: 'tag'
    }), ["orion", "aldebaran"]);
    T.eq(ISL.match(isl, 3, {
      pick: 'tag'
    }), ["orion", "aldebaran"]);
    T.eq(ISL.match(isl, 4, {
      pick: 'tag'
    }), ["orion", "aldebaran"]);
    T.eq(ISL.match(isl, 5, {
      pick: 'tag'
    }), ["cygnus", "orion", "aldebaran"]);
    T.eq(ISL.match(isl, 6, {
      pick: 'tag'
    }), ["cygnus", "orion", "aldebaran"]);
    T.eq(ISL.match(isl, 7, {
      pick: 'tag'
    }), ["cygnus", "orion", "aldebaran"]);
    T.eq(ISL.match(isl, 8, {
      pick: 'tag'
    }), ["orion", "aldebaran"]);
    T.eq(ISL.match(isl, 9, {
      pick: 'tag'
    }), ["orion", "aldebaran"]);
    T.eq(ISL.match(isl, 10, {
      pick: 'tag'
    }), ["orion", "aldebaran"]);
    T.eq(ISL.match(isl, 11, {
      pick: 'tag'
    }), ["orion", "aldebaran", "cygnus"]);
    T.eq(ISL.match(isl, 12, {
      pick: 'tag'
    }), ["orion", "aldebaran", "cygnus"]);
    T.eq(ISL.match(isl, 13, {
      pick: 'tag'
    }), ["orion", "aldebaran", "cygnus"]);
    T.eq(ISL.match(isl, 14, {
      pick: 'tag'
    }), ["orion", "aldebaran", "cygnus"]);
    T.eq(ISL.match(isl, 15, {
      pick: 'tag'
    }), ["aldebaran", "cygnus"]);
    T.eq(ISL.match(isl, 16, {
      pick: 'tag'
    }), ["aldebaran"]);
    T.eq(ISL.match(isl, 17, {
      pick: 'tag'
    }), ["aldebaran"]);
    T.eq(ISL.match(isl, 18, {
      pick: 'tag'
    }), ["aldebaran"]);
    return null;
  };

  this["test interval tree 3"] = function(T) {
    var entry, error_count, hi, i, intervals, isl, len, lo, name, ref, type;
    isl = ISL["new"]();
    intervals = [[17, 19, 'plane', 'A'], [5, 8, 'plane', 'B'], [21, 24, 'block', 'A'], [4, 8, 'block', 'D']];
    for (i = 0, len = intervals.length; i < len; i++) {
      ref = intervals[i], lo = ref[0], hi = ref[1], type = ref[2], name = ref[3];
      ISL.add(isl, {
        lo: lo,
        hi: hi,
        type: type,
        name: name
      });
    }
    show(isl);
    error_count = 0;
    T.eq(ISL.intersect(isl, [18, 22]), [
      {
        "lo": 17,
        "hi": 19,
        "type": "plane",
        "name": "A",
        "idx": 0,
        "id": "A[0]",
        "size": 3
      }, {
        "lo": 21,
        "hi": 24,
        "type": "block",
        "name": "A",
        "idx": 2,
        "id": "A[1]",
        "size": 4
      }
    ]);
    T.eq((function() {
      var j, len1, ref1, results;
      ref1 = ISL.intersect(isl, [18, 22]);
      results = [];
      for (j = 0, len1 = ref1.length; j < len1; j++) {
        entry = ref1[j];
        if (entry['type'] === 'block') {
          results.push(entry);
        }
      }
      return results;
    })(), [
      {
        "lo": 21,
        "hi": 24,
        "type": "block",
        "name": "A",
        "idx": 2,
        "id": "A[1]",
        "size": 4
      }
    ]);
    T.eq(ISL.match(isl, [2, 30]), []);
    T.eq(ISL.intersect(isl, 18), [
      {
        "lo": 17,
        "hi": 19,
        "type": "plane",
        "name": "A",
        "idx": 0,
        "id": "A[0]",
        "size": 3
      }
    ]);
    T.eq(ISL.match(isl, 18), [
      {
        "lo": 17,
        "hi": 19,
        "type": "plane",
        "name": "A",
        "idx": 0,
        "id": "A[0]",
        "size": 3
      }
    ]);
    return null;
  };

  this["characters as points 1"] = function(T) {
    var a_cid, entry, isl, z_cid;
    a_cid = 'a'.codePointAt(0);
    z_cid = 'z'.codePointAt(0);
    isl = ISL["new"]();
    ISL.add(isl, {
      lo: a_cid,
      hi: z_cid,
      name: 'Basic Latin:Lower Case'
    });
    entry = (ISL.entries_of(isl))[0];
    T.eq(entry['lo'], a_cid);
    T.eq(entry['hi'], z_cid);
    T.eq(isl['min'], a_cid);
    T.eq(isl['max'], z_cid);
    T.eq(isl['fmin'], a_cid);
    T.eq(isl['fmax'], z_cid);
    isl = ISL["new"]();
    ISL.add(isl, {
      lo: 'a',
      hi: 'z',
      name: 'Basic Latin:Lower Case'
    });
    entry = (ISL.entries_of(isl))[0];
    T.eq(entry['lo'], a_cid);
    T.eq(entry['hi'], z_cid);
    T.eq(isl['min'], a_cid);
    T.eq(isl['max'], z_cid);
    T.eq(isl['fmin'], a_cid);
    T.eq(isl['fmax'], z_cid);
    return null;
  };

  this["characters as points 3"] = function(T) {
    var chr, i, isl, j, k, len, len1, len2, ref, ref1, ref2;
    throw new Error("not implemented");
    isl = ISL["new"]();
    ISL.add(isl, {
      lo: 0x00,
      hi: 0x7f,
      name: 'basic-latin'
    });
    ISL.add(isl, {
      lo: 'a',
      hi: 'z',
      name: 'letter'
    });
    ISL.add(isl, {
      lo: 'A',
      hi: 'Z',
      name: 'letter'
    });
    ISL.add(isl, {
      lo: 'a',
      hi: 'z',
      name: 'lower'
    });
    ISL.add(isl, {
      lo: 'A',
      hi: 'Z',
      name: 'upper'
    });
    ref = 'aeiouAEIOU';
    for (i = 0, len = ref.length; i < len; i++) {
      chr = ref[i];
      ISL.add(isl, {
        lo: chr,
        hi: chr,
        name: 'vowel'
      });
    }
    ref1 = 'bcdfghjklmnpqrstvwxyzBCDFGHJKLMNPQRSTVWXYZ';
    for (j = 0, len1 = ref1.length; j < len1; j++) {
      chr = ref1[j];
      ISL.add(isl, {
        lo: chr,
        hi: chr,
        name: 'consonant'
      });
    }
    ref2 = '0123456789';
    for (k = 0, len2 = ref2.length; k < len2; k++) {
      chr = ref2[k];
      ISL.add(isl, {
        lo: chr,
        hi: chr,
        name: 'digit'
      });
    }
    T.eq(find_names_text(isl, ['c']), 'basic-latin,consonant,letter,lower');
    T.eq(find_names_text(isl, ['C']), 'basic-latin,consonant,letter,upper');
    T.eq(find_names_text(isl, ['c', 'C']), 'basic-latin,consonant,letter');
    T.eq(find_names_text(isl, ['C', 'C']), 'basic-latin,consonant,letter,upper');
    T.eq(find_names_text(isl, ['C', 'A']), 'basic-latin,letter,upper');
    T.eq(find_names_text(isl, ['c', 'A']), 'basic-latin,letter');
    T.eq(find_names_text(isl, ['A', 'e']), 'basic-latin,letter,vowel');
    T.eq(find_names_text(isl, ['i', 'e']), 'basic-latin,letter,lower,vowel');
    T.eq(find_names_text(isl, ['2', 'e']), 'basic-latin');
    return null;
  };

  this["intervals_from_points"] = function(T) {
    var A_cid, B_cid, C_cid, X_cid, Y_cid, Z_cid, isl;
    isl = ISL["new"]();
    T.eq(ISL.intervals_from_points(isl, [3, 4, 5]), [
      {
        lo: 3,
        hi: 5
      }
    ]);
    T.eq(ISL.intervals_from_points(isl, [3, 4, 5, 7, 8, 9, 10]), [
      {
        lo: 3,
        hi: 5
      }, {
        lo: 7,
        hi: 10
      }
    ]);
    T.eq(ISL.intervals_from_points(isl, [7, 10]), [
      {
        lo: 7,
        hi: 7
      }, {
        lo: 10,
        hi: 10
      }
    ]);
    A_cid = 'A'.codePointAt(0);
    B_cid = 'B'.codePointAt(0);
    C_cid = 'C'.codePointAt(0);
    X_cid = 'X'.codePointAt(0);
    Y_cid = 'Y'.codePointAt(0);
    Z_cid = 'Z'.codePointAt(0);
    T.eq(ISL.intervals_from_points(isl, Array.from('CBABAXZY')), [
      {
        lo: A_cid,
        hi: C_cid
      }, {
        lo: X_cid,
        hi: Z_cid
      }
    ]);
    T.eq(ISL.intervals_from_points(isl, Array.from('CBABAXZY'), {
      name: 'foo'
    }), [
      {
        lo: A_cid,
        hi: C_cid,
        name: 'foo'
      }, {
        lo: X_cid,
        hi: Z_cid,
        name: 'foo'
      }
    ]);
    return null;
  };

  this["intervals without ID, name"] = function(T) {
    var isl;
    isl = ISL["new"]();
    ISL.add(isl, {
      lo: 'a',
      'hi': 'z'
    });
    ISL.add(isl, {
      lo: 'a',
      'hi': 'k',
      id: 'lower-half'
    });
    ISL.add(isl, {
      lo: 'l',
      'hi': 'z',
      name: 'upper-half'
    });
    T.eq(ISL.intersect(isl, ['c', 'm']), [
      {
        "lo": 97,
        "hi": 122,
        "idx": 0,
        "id": "+[0]",
        "name": "+",
        "size": 26
      }, {
        "lo": 97,
        "hi": 107,
        "id": "lower-half",
        "idx": 1,
        "name": "+",
        "size": 11
      }, {
        "lo": 108,
        "hi": 122,
        "name": "upper-half",
        "idx": 2,
        "id": "upper-half[0]",
        "size": 15
      }
    ]);
    return null;
  };

  this["aggregation 1"] = function(T) {

    /*
    《 0x300a
     */
    var entries, entry, i, isl, len, replacers;
    entries = [
      {
        lo: 0x0,
        hi: 0x10ffff,
        type: 'style',
        name: 'fallback',
        tex: 'mktsRsgFb'
      }, {
        lo: 0x0,
        hi: 0xffff,
        type: 'plane',
        name: 'Basic Multilingual Plane (BMP)'
      }, {
        lo: 0x2e80,
        hi: 0x33ff,
        type: 'area',
        name: 'CJK Miscellaneous Area'
      }, {
        lo: 0x3000,
        hi: 0x303f,
        type: 'block',
        name: 'CJK Symbols and Punctuation',
        rsg: 'u-cjk-sym',
        is_cjk: true,
        tex: 'cnsymOld'
      }, {
        lo: 0x3000,
        hi: 0x303f,
        type: 'block',
        name: 'CJK Symbols and Punctuation',
        rsg: 'u-cjk-sym',
        is_cjk: true,
        tex: 'cnsymNew'
      }, {
        lo: 0x300a,
        hi: 0x300a,
        type: 'style',
        name: 'glyph-0x300a',
        rsg: 'u-cjk-sym',
        style: {
          raise: -0.2
        }
      }
    ];
    isl = ISL["new"]();
    for (i = 0, len = entries.length; i < len; i++) {
      entry = entries[i];
      ISL.add(isl, entry);
    }
    replacers = {
      type: 'list',
      style: 'list',
      tex: 'list',
      rsg: 'assign'
    };
    entry = ISL.aggregate(isl, '《'.codePointAt(0), replacers);
    debug(JSON.stringify(entry));
    help(entry);
    T.eq(entry, {
      type: ['style', 'plane', 'area', 'block', 'block', 'style'],
      name: 'glyph-0x300a',
      tex: ['mktsRsgFb', 'cnsymOld', 'cnsymNew'],
      rsg: 'u-cjk-sym',
      is_cjk: true,
      style: [
        {
          raise: -0.2
        }
      ]
    });
    return null;
  };

  this["aggregation 2"] = function(T) {
    var isl, reducers;
    isl = ISL["new"]();
    ISL.add(isl, {
      lo: 0,
      hi: 10,
      id: 'wide',
      count: 10,
      length: 10,
      foo: 'D'
    });
    ISL.add(isl, {
      lo: 3,
      hi: 7,
      id: 'narrow',
      count: 4,
      length: 4,
      foo: 'UH'
    });
    reducers = {
      '*': 'list',
      id: 'include',
      lo: 'assign',
      hi: 'assign',
      name: 'assign',
      count: 'add',
      length: 'average',
      foo: function(ids_and_values) {
        var id, value;
        return (((function() {
          var i, len, ref, results;
          results = [];
          for (i = 0, len = ids_and_values.length; i < len; i++) {
            ref = ids_and_values[i], id = ref[0], value = ref[1];
            results.push(value.toLowerCase());
          }
          return results;
        })()).join('')) + '!';
      }
    };
    debug(JSON.stringify(ISL.aggregate(isl, 5, reducers)));
    T.eq(ISL.aggregate(isl, 5, reducers), {
      "lo": 3,
      "hi": 7,
      "id": ["wide", "narrow"],
      "count": 14,
      "name": "+",
      "length": 7,
      "foo": "duh!"
    });
    return null;
  };

  this["readme example 1"] = function(T) {
    var chr, consonants, digits, i, interval, isl, j, k, len, len1, len2, ref, ref1, ref2;
    isl = ISL["new"]();
    ISL.add(isl, {
      lo: 0x00,
      hi: 0x7f,
      name: 'basic-latin'
    });
    ISL.add(isl, {
      lo: 'a',
      hi: 'z',
      name: 'letter'
    });
    ISL.add(isl, {
      lo: 'A',
      hi: 'Z',
      name: 'letter'
    });
    ISL.add(isl, {
      lo: 'a',
      hi: 'z',
      name: 'lower'
    });
    ISL.add(isl, {
      lo: 'A',
      hi: 'Z',
      name: 'upper'
    });
    ref = 'aeiouAEIOU';
    for (i = 0, len = ref.length; i < len; i++) {
      chr = ref[i];
      ISL.add(isl, {
        lo: chr,
        hi: chr,
        name: 'vowel'
      });
    }
    consonants = Array.from('bcdfghjklmnpqrstvwxyzBCDFGHJKLMNPQRSTVWXYZ');
    ref1 = ISL.intervals_from_points(isl, consonants, {
      name: 'consonant'
    });
    for (j = 0, len1 = ref1.length; j < len1; j++) {
      interval = ref1[j];
      ISL.add(isl, interval);
    }
    digits = Array.from('0123456789');
    ref2 = ISL.intervals_from_points(isl, digits, {
      name: 'digit'
    });
    for (k = 0, len2 = ref2.length; k < len2; k++) {
      interval = ref2[k];
      ISL.add(isl, interval);
    }
    show(isl);
    return null;
  };

  this["readme example 2"] = function(T) {
    var replacers, samples;
    samples = ISL["new"]();
    ISL.add(samples, {
      lo: 0x0000,
      hi: 0x10ffff,
      name: 'base',
      font_family: 'Arial'
    });
    ISL.add(samples, {
      lo: 0x00,
      hi: 0xff,
      name: 'ascii',
      font_family: 'Arial'
    });
    ISL.add(samples, {
      lo: 0x4e00,
      hi: 0x9fff,
      name: 'cjk',
      font_family: 'Sun-ExtA'
    });
    ISL.add(samples, {
      lo: 0x3040,
      hi: 0x309f,
      name: 'cjk',
      font_family: 'Sun-ExtA'
    });
    ISL.add(samples, {
      lo: 0x26,
      hi: 0x26,
      name: 'ampersand',
      font_family: 'Baskerville'
    });
    T.eq(ISL._find_ids_with_all_points(samples, 'A'), ISL.match(samples, 'A', {
      pick: 'id'
    }));
    T.eq(ISL._find_ids_with_all_points(samples, '&'), ISL.match(samples, '&', {
      pick: 'id'
    }));
    T.eq(ISL._find_ids_with_all_points(samples, '人'), ISL.match(samples, '人', {
      pick: 'id'
    }));
    T.eq(ISL.intersect(samples, 'A'), ISL.match(samples, 'A'));
    T.eq(ISL.intersect(samples, '&'), ISL.match(samples, '&'));
    T.eq(ISL.intersect(samples, '人'), ISL.match(samples, '人'));
    urge('rx2-7', 'A', ISL.aggregate(samples, 'A'));
    urge('rx2-8', '&', ISL.aggregate(samples, '&'));
    urge('rx2-9', '人', ISL.aggregate(samples, '人'));
    replacers = {
      '*': 'list',
      name: 'include'
    };
    info('rx2-10', 'A', ISL.aggregate(samples, 'A', replacers));
    info('rx2-11', '&', ISL.aggregate(samples, '&', replacers));
    info('rx2-12', '人', ISL.aggregate(samples, '人', replacers));
    return null;
  };

  this["demo discontiguous ranges"] = function(T) {
    var u;
    u = ISL["new"]();
    ISL.add(u, {
      lo: 0x4e00,
      hi: 0x9fff,
      name: 'cjk',
      id: 'u-cjk'
    });
    ISL.add(u, {
      lo: 0xff00,
      hi: 0xffef,
      name: 'cjk',
      id: 'u-halfull'
    });
    ISL.add(u, {
      lo: 0x3400,
      hi: 0x4dbf,
      name: 'cjk',
      id: 'u-cjk-xa'
    });
    ISL.add(u, {
      lo: 0x20000,
      hi: 0x2a6df,
      name: 'cjk',
      id: 'u-cjk-xb'
    });
    ISL.add(u, {
      lo: 0x2a700,
      hi: 0x2b73f,
      name: 'cjk',
      id: 'u-cjk-xc'
    });
    ISL.add(u, {
      lo: 0x2b740,
      hi: 0x2b81f,
      name: 'cjk',
      id: 'u-cjk-xd'
    });
    ISL.add(u, {
      lo: 0x2b820,
      hi: 0x2ceaf,
      name: 'cjk',
      id: 'u-cjk-xe'
    });
    ISL.add(u, {
      lo: 0xf900,
      hi: 0xfaff,
      name: 'cjk',
      id: 'u-cjk-cmpi1'
    });
    ISL.add(u, {
      lo: 0x2f800,
      hi: 0x2fa1f,
      name: 'cjk',
      id: 'u-cjk-cmpi2'
    });
    ISL.add(u, {
      lo: 0x2f00,
      hi: 0x2fdf,
      name: 'cjk',
      id: 'u-cjk-rad1'
    });
    ISL.add(u, {
      lo: 0x2e80,
      hi: 0x2eff,
      name: 'cjk',
      id: 'u-cjk-rad2'
    });
    ISL.add(u, {
      lo: 0x3000,
      hi: 0x303f,
      name: 'cjk',
      id: 'u-cjk-sym'
    });
    ISL.add(u, {
      lo: 0x31c0,
      hi: 0x31ef,
      name: 'cjk',
      id: 'u-cjk-strk'
    });
    ISL.add(u, {
      lo: 0x30a0,
      hi: 0x30ff,
      name: 'cjk',
      id: 'u-cjk-kata'
    });
    ISL.add(u, {
      lo: 0x3040,
      hi: 0x309f,
      name: 'cjk',
      id: 'u-cjk-hira'
    });
    ISL.add(u, {
      lo: 0xac00,
      hi: 0xd7af,
      name: 'cjk',
      id: 'u-hang-syl'
    });
    ISL.add(u, {
      lo: 0x3200,
      hi: 0x32ff,
      name: 'cjk',
      id: 'u-cjk-enclett'
    });
    return null;
  };

  this["unique names with priority conflict"] = function(T) {
    var isl;
    isl = ISL["new"]();
    ISL.add(isl, {
      lo: 15,
      hi: 20,
      id: 'alpha-0',
      name: 'alpha'
    });
    ISL.add(isl, {
      lo: 15,
      hi: 25,
      id: 'beta-0',
      name: 'beta'
    });
    ISL.add(isl, {
      lo: 15,
      hi: 25,
      id: 'omega-0',
      name: 'omega'
    });
    ISL.add(isl, {
      lo: 15,
      hi: 49,
      id: 'gamma-0',
      name: 'gamma'
    });
    ISL.add(isl, {
      lo: 15,
      hi: 29,
      id: 'beta-1',
      name: 'beta'
    });
    show(isl);
    T.eq(ISL.match(isl, 15, {
      pick: 'id'
    }), ["alpha-0", "beta-0", "omega-0", "gamma-0", "beta-1"]);
    T.eq(ISL.match(isl, 15, {
      pick: 'name'
    }), ["alpha", "omega", "gamma", "beta"]);
    return null;
  };

  this["tag 1"] = function(T) {
    var digit, digit_0, digit_1, i, j, n, u;
    u = ISL["new"]();
    ISL.add(u, {
      lo: 0x00,
      hi: 0x7f,
      name: 'ascii'
    });
    for (n = i = 0; i <= 8; n = i += +2) {
      digit_0 = "" + n;
      digit_1 = "" + (n + 1);
      ISL.add(u, {
        lo: digit_0,
        hi: digit_0,
        tag: ['ascii', 'digit', 'even']
      });
      ISL.add(u, {
        lo: digit_1,
        hi: digit_1,
        tag: ['ascii', 'digit', 'odd']
      });
    }
    ISL.add(u, {
      lo: '2',
      hi: '2',
      tag: ['prime']
    });
    ISL.add(u, {
      lo: '3',
      hi: '3',
      tag: ['prime']
    });
    ISL.add(u, {
      lo: '5',
      hi: '5',
      tag: ['prime']
    });
    ISL.add(u, {
      lo: '7',
      hi: '7',
      tag: ['prime']
    });
    for (n = j = 0; j <= 9; n = ++j) {
      digit = "" + n;
      help(digit, ISL.aggregate(u, digit, {
        '*': 'skip',
        tag: 'tag'
      }));
    }
    T.eq(ISL.aggregate(u, '3', {
      '*': 'skip',
      tag: 'tag'
    }), {
      tag: ['ascii', 'digit', 'odd', 'prime']
    });
    return null;
  };

  this["tag 2"] = function(T) {
    var digit_0, digit_1, i, n, u;
    u = ISL["new"]();
    ISL.add(u, {
      lo: 0x00,
      hi: 0x7f,
      name: 'ascii'
    });
    for (n = i = 0; i <= 8; n = i += +2) {
      digit_0 = "" + n;
      digit_1 = "" + (n + 1);
      ISL.add(u, {
        lo: digit_0,
        hi: digit_0,
        tag: ['ascii', 'digit', 'even']
      });
      ISL.add(u, {
        lo: digit_1,
        hi: digit_1,
        tag: ['ascii', 'digit', 'odd']
      });
    }
    ISL.add(u, {
      lo: '2',
      hi: '2',
      tag: 'prime'
    });
    ISL.add(u, {
      lo: '3',
      hi: '3',
      tag: 'prime'
    });
    ISL.add(u, {
      lo: '5',
      hi: '5',
      tag: 'prime'
    });
    ISL.add(u, {
      lo: '7',
      hi: '7',
      tag: 'prime'
    });
    T.eq(ISL.aggregate(u, '3'), {
      name: '+',
      tag: ['ascii', 'digit', 'odd', 'prime']
    });
    return null;
  };

  this["tag 2a"] = function(T) {
    var digit_0, i, j, len, matcher, n, probe, probes_and_matchers, ref, result, u;
    probes_and_matchers = [
      [
        '0', {
          tag: ['digit', 'even']
        }
      ], [
        '1', {
          tag: ['digit', 'odd']
        }
      ], [
        '2', {
          tag: ['digit', 'even']
        }
      ], [
        '3', {
          tag: ['digit', 'odd']
        }
      ], [
        '4', {
          tag: ['digit', 'even']
        }
      ], [
        '5', {
          tag: ['digit', 'odd']
        }
      ], [
        '6', {
          tag: ['digit', 'even']
        }
      ], [
        '7', {
          tag: ['digit', 'odd']
        }
      ], [
        '8', {
          tag: ['digit', 'even']
        }
      ], [
        '9', {
          tag: ['digit', 'odd']
        }
      ]
    ];
    u = ISL["new"]();
    ISL.add(u, {
      lo: 0x00,
      hi: 0x7f,
      name: 'ascii'
    });
    ISL.add(u, {
      lo: '0',
      hi: '9',
      tag: ['digit', 'even']
    });
    for (n = i = 1; i <= 9; n = i += +2) {
      digit_0 = "" + n;
      ISL.add(u, {
        lo: digit_0,
        hi: digit_0,
        tag: ['-even', 'odd']
      });
    }
    for (j = 0, len = probes_and_matchers.length; j < len; j++) {
      ref = probes_and_matchers[j], probe = ref[0], matcher = ref[1];
      result = ISL.aggregate(u, probe, {
        name: 'skip'
      });
      T.eq(result, matcher);
    }
    return null;
  };

  this["tag 2b"] = function(T) {
    var digit_0, i, j, len, matcher, n, probe, probes_and_matchers, ref, result, u;
    probes_and_matchers = [
      [
        '0', {
          tag: ['digit', 'even']
        }
      ], [
        '1', {
          tag: ['digit', 'odd']
        }
      ], [
        '2', {
          tag: ['digit', 'even']
        }
      ], [
        '3', {
          tag: ['digit', 'odd']
        }
      ], [
        '4', {
          tag: ['digit', 'even']
        }
      ], [
        '5', {
          tag: ['digit', 'odd']
        }
      ], [
        '6', {
          tag: ['digit', 'even']
        }
      ], [
        '7', {
          tag: ['digit', 'odd']
        }
      ], [
        '8', {
          tag: ['digit', 'even']
        }
      ], [
        '9', {
          tag: ['digit', 'odd']
        }
      ]
    ];
    u = ISL["new"]();
    ISL.add(u, {
      lo: 0x00,
      hi: 0x7f,
      name: 'ascii'
    });
    ISL.add(u, {
      lo: '0',
      hi: '9',
      tag: 'digit even'
    });
    for (n = i = 1; i <= 9; n = i += +2) {
      digit_0 = "" + n;
      ISL.add(u, {
        lo: digit_0,
        hi: digit_0,
        tag: '-even odd'
      });
    }
    for (j = 0, len = probes_and_matchers.length; j < len; j++) {
      ref = probes_and_matchers[j], probe = ref[0], matcher = ref[1];
      result = ISL.aggregate(u, probe, {
        name: 'skip'
      });
      T.eq(result, matcher);
    }
    return null;
  };

  this["tag 3"] = function(T) {
    var digit_0, digit_1, i, n, u;
    u = ISL["new"]();
    ISL.add(u, {
      lo: 0x00,
      hi: 0x7f,
      tag: 'ascii'
    });
    ISL.add(u, {
      lo: 0x00,
      hi: 0x7f,
      name: 'ascii-duplicate'
    });
    for (n = i = 0; i <= 8; n = i += +2) {
      digit_0 = "" + n;
      digit_1 = "" + (n + 1);
      ISL.add(u, {
        lo: digit_0,
        hi: digit_0,
        tag: ['ascii', 'digit', 'even']
      });
      ISL.add(u, {
        lo: digit_1,
        hi: digit_1,
        tag: ['ascii', 'digit', 'odd']
      });
    }
    ISL.add(u, {
      lo: '2',
      hi: '2',
      tag: 'prime'
    });
    ISL.add(u, {
      lo: '3',
      hi: '3',
      tag: 'prime'
    });
    ISL.add(u, {
      lo: '5',
      hi: '5',
      tag: 'prime'
    });
    ISL.add(u, {
      lo: '7',
      hi: '7',
      tag: 'prime'
    });
    T.eq(ISL.aggregate(u, '3'), {
      name: '+',
      tag: ['ascii', 'digit', 'odd', 'prime']
    });
    info(u);
    return null;
  };

  this["configurable reducers, negative tags"] = function(T) {
    var add, description, descriptions, i, j, len, len1, matcher, probe, probes_and_matchers, ref, tag_reducer, u;
    add = function(isl, description) {
      var hi, interval, lo, name, rsg, tag, tail, type;
      rsg = null;
      tag = null;
      type = description[0], tail = 2 <= description.length ? slice.call(description, 1) : [];
      switch (type) {
        case 'block':
          name = tail[0], rsg = tail[1], lo = tail[2], hi = tail[3], tag = tail[4];
          break;
        case 'plane':
        case 'area':
          name = tail[0], lo = tail[1], hi = tail[2], tag = tail[3];
          break;
        case 'codepoints':
          lo = tail[0], hi = tail[1], tag = tail[2];
          break;
        default:
          throw new Error("unknown entry type " + (rpr(type)));
      }
      interval = {
        lo: lo,
        hi: hi
      };
      if (name != null) {
        interval[type] = name;
      }
      if (rsg != null) {
        interval['rsg'] = rsg;
      }
      if (tag != null) {
        interval['tag'] = tag.split(/[\s,]+/);
      }
      ISL.add(isl, interval);
      return null;
    };
    descriptions = [['plane', 'Basic Multilingual Plane (BMP)', 0x0000, 0xffff], ['plane', 'Supplementary Multilingual Plane (SMP)', 0x10000, 0x1ffff], ['plane', 'Supplementary Ideographic Plane (SIP)', 0x20000, 0x2ffff], ['area', 'ASCII & Latin-1 Compatibility Area', 0x0000, 0x00ff], ['area', 'General Scripts Area', 0x0100, 0x058f], ['block', 'Basic Latin', 'u-latn', 0x0, 0x7f], ['block', 'Latin-1 Supplement', 'u-latn-1', 0x80, 0xff], ['block', 'Latin Extended-A', 'u-latn-a', 0x100, 0x17f], ['block', 'Latin Extended-B', 'u-latn-b', 0x180, 0x24f], ['block', 'IPA Extensions', 'u-ipa-x', 0x250, 0x2af], ['block', 'Armenian', null, 0x530, 0x58f], ['block', 'CJK Unified Ideographs', 'u-cjk', 0x4e00, 0x9fff, 'cjk ideograph'], ['block', 'CJK Unified Ideographs Extension A', 'u-cjk-xa', 0x3400, 0x4dbf, 'cjk ideograph'], ['block', 'CJK Unified Ideographs Extension B', 'u-cjk-xb', 0x20000, 0x2a6df, 'cjk ideograph'], ['block', 'CJK Unified Ideographs Extension C', 'u-cjk-xc', 0x2a700, 0x2b73f, 'cjk ideograph'], ['block', 'CJK Unified Ideographs Extension D', 'u-cjk-xd', 0x2b740, 0x2b81f, 'cjk ideograph'], ['block', 'CJK Unified Ideographs Extension E', 'u-cjk-xe', 0x2b820, 0x2ceaf, 'cjk ideograph'], ['block', 'CJK Unified Ideographs Extension F', 'u-cjk-xf', 0x2ceb0, 0x2ebef, 'cjk ideograph'], ['block', 'Ideographic Description Characters', 'u-cjk-idc', 0x2ff0, 0x2fff, 'cjk idl'], ['block', 'CJK Symbols and Punctuation', 'u-cjk-sym', 0x3000, 0x303f, 'cjk punctuation'], ['block', 'CJK Strokes', 'u-cjk-strk', 0x31c0, 0x31ef, 'cjk stroke'], ['block', 'Enclosed CJK Letters and Months', 'u-cjk-enclett', 0x3200, 0x32ff, 'cjk'], ['block', 'Kangxi Radicals', 'u-cjk-rad1', 0x2f00, 0x2fdf, 'cjk ideograph kxr'], ['block', 'CJK Radicals Supplement', 'u-cjk-rad2', 0x2e80, 0x2eff, 'cjk ideograph'], ['block', 'Hiragana', 'u-cjk-hira', 0x3040, 0x309f, 'cjk japanese kana hiragana'], ['block', 'Katakana', 'u-cjk-kata', 0x30a0, 0x30ff, 'cjk japanese kana katakana'], ['block', 'Kanbun', 'u-cjk-kanbun', 0x3190, 0x319f, 'cjk japanese kanbun'], ['block', 'Katakana Phonetic Extensions', 'u-cjk-kata-x', 0x31f0, 0x31ff, 'cjk japanese kana katakana'], ['block', 'Hangul Jamo', 'u-hang-jm', 0x1100, 0x11ff, 'cjk korean hangeul jamo'], ['block', 'Hangul Syllables', 'u-hang-syl', 0xac00, 0xd7af, 'cjk korean hangeul syllable'], ['block', 'Hangul Jamo Extended-A', null, 0xa960, 0xa97f, 'cjk korean hangeul jamo'], ['block', 'Hangul Jamo Extended-B', null, 0xd7b0, 0xd7ff, 'cjk korean hangeul jamo'], ['block', 'Bopomofo', 'u-bopo', 0x3100, 0x312f, 'cjk bopomofo'], ['block', 'Bopomofo Extended', 'u-bopo-x', 0x31a0, 0x31bf, 'cjk bopomofo'], ['block', 'CJK Compatibility Forms', 'u-cjk-cmpf', 0xfe30, 0xfe4f, 'cjk vertical'], ['codepoints', 0xfe45, 0xfe46, '-vertical'], ['codepoints', 0xfe49, 0xfe4f, '-vertical'], ['block', 'Vertical Forms', 'u-vertf', 0xfe10, 0xfe1f, 'cjk vertical'], ['block', 'Miscellaneous Symbols', 'u-sym', 0x2600, 0x26ff], ['codepoints', 0x262f, 0x2637, 'cjk'], ['codepoints', 0x2630, 0x2637, 'cjk yijing trigram'], ['block', 'Yijing Hexagram Symbols', 'u-yijng', 0x4dc0, 0x4dff, 'cjk yijing hexagram'], ['block', 'Tai Xuan Jing Symbols', 'u-txj-sym', 0x1d300, 0x1d35f, 'cjk yijing taixuanjing tetragram'], ['codepoints', 0x1d357, 0x1d35f, '-* reserved'], ['block', 'CJK Compatibility Ideographs', 'u-cjk-cmpi1', 0xf900, 0xfaff, 'cjk'], ['block', 'Hangul Compatibility Jamo', 'u-hang-comp-jm', 0x3130, 0x318f, 'cjk'], ['block', 'CJK Compatibility', 'u-cjk-cmp', 0x3300, 0x33ff, 'cjk'], ['block', 'CJK Compatibility Ideographs Supplement', 'u-cjk-cmpi2', 0x2f800, 0x2fa1f, 'cjk'], ['block', 'Private Use Area', 'u-pua', 0xe000, 0xf8ff]];
    probes_and_matchers = [
      [
        "a", {
          "plane": "Basic Multilingual Plane (BMP)",
          "area": "ASCII & Latin-1 Compatibility Area",
          "block": "Basic Latin",
          "rsg": "u-latn"
        }
      ], [
        "ä", {
          "plane": "Basic Multilingual Plane (BMP)",
          "area": "ASCII & Latin-1 Compatibility Area",
          "block": "Latin-1 Supplement",
          "rsg": "u-latn-1"
        }
      ], [
        "ɐ", {
          "plane": "Basic Multilingual Plane (BMP)",
          "area": "General Scripts Area",
          "block": "IPA Extensions",
          "rsg": "u-ipa-x"
        }
      ], [
        "ա", {
          "plane": "Basic Multilingual Plane (BMP)",
          "area": "General Scripts Area",
          "block": "Armenian"
        }
      ], [
        "三", {
          "plane": "Basic Multilingual Plane (BMP)",
          "block": "CJK Unified Ideographs",
          "rsg": "u-cjk",
          "tag": ["cjk", "ideograph"]
        }
      ], [
        "ゆ", {
          "plane": "Basic Multilingual Plane (BMP)",
          "block": "Hiragana",
          "rsg": "u-cjk-hira",
          "tag": ["cjk", "japanese", "kana", "hiragana"]
        }
      ], [
        "㈪", {
          "plane": "Basic Multilingual Plane (BMP)",
          "block": "Enclosed CJK Letters and Months",
          "rsg": "u-cjk-enclett",
          "tag": ["cjk"]
        }
      ], [
        "《", {
          "plane": "Basic Multilingual Plane (BMP)",
          "block": "CJK Symbols and Punctuation",
          "rsg": "u-cjk-sym",
          "tag": ["cjk", "punctuation"]
        }
      ], [
        "》", {
          "plane": "Basic Multilingual Plane (BMP)",
          "block": "CJK Symbols and Punctuation",
          "rsg": "u-cjk-sym",
          "tag": ["cjk", "punctuation"]
        }
      ], [
        "𫠠", {
          "plane": "Supplementary Ideographic Plane (SIP)",
          "block": "CJK Unified Ideographs Extension E",
          "rsg": "u-cjk-xe",
          "tag": ["cjk", "ideograph"]
        }
      ], [
        "﹄", {
          "plane": "Basic Multilingual Plane (BMP)",
          "block": "CJK Compatibility Forms",
          "rsg": "u-cjk-cmpf",
          "tag": ["cjk", "vertical"]
        }
      ], [
        "﹅", {
          "plane": "Basic Multilingual Plane (BMP)",
          "block": "CJK Compatibility Forms",
          "rsg": "u-cjk-cmpf",
          "tag": ["cjk"]
        }
      ], [
        "𝍖", {
          "plane": "Supplementary Multilingual Plane (SMP)",
          "block": "Tai Xuan Jing Symbols",
          "rsg": "u-txj-sym",
          "tag": ["cjk", "yijing", "taixuanjing", "tetragram"]
        }
      ], [
        String.fromCodePoint(0x1d357), {
          "plane": "Supplementary Multilingual Plane (SMP)",
          "block": "Tai Xuan Jing Symbols",
          "rsg": "u-txj-sym",
          "tag": ["reserved"]
        }
      ]
    ];
    tag_reducer = function(ids_and_tags) {};
    u = ISL["new"]({
      reducers: {
        name: 'skip'
      }
    });
    for (i = 0, len = descriptions.length; i < len; i++) {
      description = descriptions[i];
      add(u, description);
    }
    for (j = 0, len1 = probes_and_matchers.length; j < len1; j++) {
      ref = probes_and_matchers[j], probe = ref[0], matcher = ref[1];
      help(s([probe, ISL.aggregate(u, probe)]));
      T.eq(ISL.aggregate(u, probe), matcher);
    }
    return null;
  };

  this["_complements"] = function(T) {

    /*
        0                   1                   2                   3                   4
    -∞  0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 +∞
    
    =============================================================================================
    ---------------------10]                   [20---------------30]                   [40-------
                                 [13---17]
    ---------------------10]                   [20---------------30]                   [40-------
    
    =============================================================================================
    ---------------------10]                   [20---------------30]                   [40-------
             [3-----7]
    --------3]       [7--10]                   [20---------------30]                   [40-------
    
    =============================================================================================
    ---------------------10]                   [20---------------30]                   [40-------
                     [7--------13]
    ----------------7]                         [20---------------30]                   [40-------
    
    =============================================================================================
    ---------------------10]                   [20---------------30]                   [40-------
                                         [17-------23]
    ---------------------10]                         [23---------30]                   [40-------
    
    =============================================================================================
    ---------------------10]                   [20---------------30]                   [40-------
                                         [17---------------------------33]
    ---------------------10]                                                           [40-------
    
    =============================================================================================
    ---------------------10]                   [20---------------30]                   [40-------
                     [7----------------------------23]
    ----------------7]                               [23---------30]                   [40-------
    
    =============================================================================================
    ---------------------10]                   [20---------------30]                   [40-------
                     [7--------------------------------------------------------------------43]
    ----------------7]                                                                       [43-
     */
    var cleanup, f, probe, result;
    f = function() {
      return this.complement_from_intervals = function(me, intervals) {
        var R, base, i, interval, isl, len;
        R = [];
        base = {
          lo: Number.MIN_VALUE,
          hi: Number.MAX_VALUE
        };
        isl = this["new"]();
        ISL.add(isl, base);
        if (intervals.length === 0) {
          R.push(base);
        } else {
          for (i = 0, len = intervals.length; i < len; i++) {
            interval = intervals[i];
            null;
          }
        }
        return R;
      };
    };
    f.apply(ISL);
    cleanup = function(intervals) {
      var i, interval, len;
      for (i = 0, len = intervals.length; i < len; i++) {
        interval = intervals[i];
        delete interval['id'];
        delete interval['name'];
        delete interval['idx'];
        delete interval['size'];
      }
      return intervals;
    };
    probe = [];
    result = cleanup(ISL.complement_from_intervals(null, probe));
    T.eq(result, [
      {
        lo: Number.MIN_VALUE,
        hi: Number.MAX_VALUE
      }
    ]);
    return null;
  };

  this["infinity is a valid number"] = function(T) {
    var r;
    r = ISL["new"]();
    ISL.add(r, {
      lo: -Infinity,
      hi: +Infinity,
      tag: 'all'
    });
    ISL.add(r, {
      lo: -1e6,
      hi: +1e6,
      tag: 'finite'
    });
    ISL.add(r, {
      lo: -1e5,
      hi: +1e5,
      tag: 'truly-huge'
    });
    ISL.add(r, {
      lo: -1e4,
      hi: +1e4,
      tag: 'huge'
    });
    ISL.add(r, {
      lo: -1e3,
      hi: +1e3,
      tag: 'big'
    });
    ISL.add(r, {
      lo: -1e2,
      hi: +1e2,
      tag: 'sizable'
    });
    ISL.add(r, {
      lo: -1e1,
      hi: +1e1,
      tag: 'small'
    });
    ISL.add(r, {
      lo: -1e0,
      hi: +1e0,
      tag: 'tiny'
    });
    T.eq(ISL.aggregate(r, 1, {
      name: 'skip'
    }), {
      "tag": ["all", "finite", "truly-huge", "huge", "big", "sizable", "small", "tiny"]
    });
    T.eq(ISL.aggregate(r, 10, {
      name: 'skip'
    }), {
      "tag": ["all", "finite", "truly-huge", "huge", "big", "sizable", "small"]
    });
    T.eq(ISL.aggregate(r, 100, {
      name: 'skip'
    }), {
      "tag": ["all", "finite", "truly-huge", "huge", "big", "sizable"]
    });
    T.eq(ISL.aggregate(r, 1000, {
      name: 'skip'
    }), {
      "tag": ["all", "finite", "truly-huge", "huge", "big"]
    });
    T.eq(ISL.aggregate(r, 10000, {
      name: 'skip'
    }), {
      "tag": ["all", "finite", "truly-huge", "huge"]
    });
    T.eq(ISL.aggregate(r, 100000, {
      name: 'skip'
    }), {
      "tag": ["all", "finite", "truly-huge"]
    });
    T.eq(ISL.aggregate(r, 1000000, {
      name: 'skip'
    }), {
      "tag": ["all", "finite"]
    });

    /* This is a glitch: interval boundaries should be inclusive, but apparentl<y `Infinity` is not
    within the boundaries of the interval with `hi: +Infinity`:
     */
    T.eq(ISL.aggregate(r, Infinity, {
      name: 'skip'
    }), {});
    return null;
  };

  this["(v3) match, intersect"] = function(T) {
    var ascii, chr, consonants, digits, i, interval, j, k, len, len1, len2, ref, ref1, ref2;
    ascii = ISL["new"]();
    ISL.add(ascii, {
      lo: 0x00,
      hi: 0x7f,
      name: 'basic-latin',
      tag: 'basic-latin'
    });
    ISL.add(ascii, {
      lo: 'a',
      hi: 'z',
      name: 'letter',
      tag: 'letter'
    });
    ISL.add(ascii, {
      lo: 'A',
      hi: 'Z',
      name: 'letter',
      tag: 'letter'
    });
    ISL.add(ascii, {
      lo: 'a',
      hi: 'z',
      name: 'lower',
      tag: 'lower'
    });
    ISL.add(ascii, {
      lo: 'A',
      hi: 'Z',
      name: 'upper',
      tag: 'upper'
    });
    ref = 'aeiouAEIOU';
    for (i = 0, len = ref.length; i < len; i++) {
      chr = ref[i];
      ISL.add(ascii, {
        lo: chr,
        hi: chr,
        name: 'vowel',
        tag: 'vowel'
      });
    }
    consonants = Array.from('bcdfghjklmnpqrstvwxyzBCDFGHJKLMNPQRSTVWXYZ');
    ref1 = ISL.intervals_from_points(ascii, consonants, {
      name: 'consonant',
      tag: 'consonant'
    });
    for (j = 0, len1 = ref1.length; j < len1; j++) {
      interval = ref1[j];
      ISL.add(ascii, interval);
    }
    digits = Array.from('0123456789');
    ref2 = ISL.intervals_from_points(ascii, digits, {
      name: 'digit',
      tag: 'digit'
    });
    for (k = 0, len2 = ref2.length; k < len2; k++) {
      interval = ref2[k];
      ISL.add(ascii, interval);
    }
    show(ascii);
    info(ISL.match(ascii, 'f'));
    info(ISL.match(ascii, ['f', 'F']));
    info(ISL.match(ascii, ['f', 'F'], {
      pick: 'id'
    }));
    info(ISL.aggregate(ascii, 'f'));
    info(ISL.aggregate(ascii, 'f', {
      name: 'list',
      tag: 'list',
      id: 'list'
    }));
    return null;
  };

  this.dump_api = function(T) {
    return debug((Object.keys(ISL)).sort());
  };

  this["(v3) copy"] = function(T) {
    var copy, i, j, key, len, len1, original, original_value, ref, ref1, ref2;
    original = ISL["new"]({
      reducers: {
        name: 'list',
        tag: function(ids_and_values) {
          return '*';
        }
      }
    });
    ISL.add(original, {
      lo: 0x00,
      hi: 0x7f,
      name: 'basic-latin',
      tag: 'basic-latin'
    });
    ISL.add(original, {
      lo: 'a',
      hi: 'z',
      name: 'letter',
      tag: 'letter'
    });
    ISL.add(original, {
      lo: 'A',
      hi: 'Z',
      name: 'letter',
      tag: 'letter'
    });
    ISL.add(original, {
      lo: 'a',
      hi: 'z',
      name: 'lower',
      tag: 'lower'
    });
    ISL.add(original, {
      lo: 'A',
      hi: 'Z',
      name: 'upper',
      tag: 'upper'
    });
    copy = ISL.copy(original);
    delete original['%self'];
    delete copy['%self'];
    ref = ['entry-by-ids', 'idx-by-names', 'ids-by-names', 'name-by-ids', 'idx-by-ids', 'ids'];
    for (i = 0, len = ref.length; i < len; i++) {
      key = ref[i];
      T.eq(original[key], copy[key]);
      T.ok(original[key] !== copy[key]);
    }
    ref1 = ['idx', 'min', 'max', 'fmin', 'fmax'];
    for (j = 0, len1 = ref1.length; j < len1; j++) {
      key = ref1[j];
      T.ok(original[key] === copy[key]);
    }
    if (original['reducers'] != null) {
      ref2 = original['reducers'];
      for (key in ref2) {
        original_value = ref2[key];
        if (CND.isa_function(original_value)) {
          T.ok(original_value === copy['reducers'][key]);
        } else {
          T.eq(original_value, copy['reducers'][key]);
        }
      }
    } else {
      T.eq(original['reducers'], copy['reducers']);
    }
    return null;
  };

  this["(v2) 53846537846"] = function(T) {
    var i, len, matcher, probe, probes_and_matchers, reducers, ref, result_A, result_B, u;
    u = ISL["new"]();
    ISL.add(u, {
      lo: 'q',
      hi: 'q',
      tag: 'assigned',
      rsg: 'u-latn'
    });
    ISL.add(u, {
      lo: '里',
      hi: '里',
      tag: 'assigned',
      rsg: 'u-cjk'
    });
    ISL.add(u, {
      lo: '里',
      hi: '里',
      tag: 'cjk ideograph'
    });
    ISL.add(u, {
      lo: '䊷',
      hi: '䊷',
      tag: 'assigned',
      rsg: 'u-cjk-xa'
    });
    ISL.add(u, {
      lo: '䊷',
      hi: '䊷',
      tag: 'cjk ideograph'
    });
    probes_and_matchers = [
      [
        'q', {
          rsg: 'u-latn',
          tag: ['assigned']
        }
      ], [
        '里', {
          rsg: 'u-cjk',
          tag: ['assigned', 'cjk', 'ideograph']
        }
      ], [
        '䊷', {
          rsg: 'u-cjk-xa',
          tag: ['assigned', 'cjk', 'ideograph']
        }
      ]
    ];
    reducers = {
      '*': 'skip',
      'tag': 'tag',
      'rsg': 'assign'
    };
    for (i = 0, len = probes_and_matchers.length; i < len; i++) {
      ref = probes_and_matchers[i], probe = ref[0], matcher = ref[1];
      result_A = ISL.aggregate(u, probe);
      result_B = ISL.aggregate(u, probe, reducers);
      T.eq(result_A['rsg'], result_B['rsg']);
      T.eq(result_A['tag'], result_B['tag']);
      T.eq(result_B, matcher);
    }
    return null;
  };

  if (module.parent == null) {
    include = ["test interval tree 1", "test interval tree 2", "test interval tree 3", "aggregation 1", "aggregation 2", "characters as points 1", "intervals_from_points", "readme example 1", "readme example 2", "intervals without ID, name", "demo discontiguous ranges", "unique names with priority conflict", "tag 1", "tag 2", "tag 2a", "tag 2b", "tag 3", "configurable reducers, negative tags", "complements", "infinity is a valid number", "(v3) match, intersect", "(v3) copy", "(v2) 53846537846"];
    this._prune();
    this._main();
  }

}).call(this);

//# sourceMappingURL=tests.js.map
